CodeForces601 A.The Two Routes (最短路)

A.The Two Routes

In Absurdistan, there are n towns (numbered 1 through n) and m bidirectional railways. There is also an absurdly simple road network — for each pair of different towns x and y, there is a bidirectional road between towns x and y if and only if there is no railway between them. Travelling to a different town using one railway or one road always takes exactly one hour.

A train and a bus leave town 1 at the same time. They both have the same destination, town n, and don’t make any stops on the way (but they can wait in town n). The train can move only along railways and the bus can move only along roads.

You’ve been asked to plan out routes for the vehicles; each route can use any road/railway multiple times. One of the most important aspects to consider is safety — in order to avoid accidents at railway crossings, the train and the bus must not arrive at the same town (except town n) simultaneously.

Under these constraints, what is the minimum number of hours needed for both vehicles to reach town n (the maximum of arrival times of the bus and the train)? Note, that bus and train are not required to arrive to the town n at the same moment of time, but are allowed to do so.

Input

The first line of the input contains two integers n and m (2 ≤ n ≤ 400, 0 ≤ m ≤ n(n - 1) / 2) — the number of towns and the number of railways respectively.

Each of the next m lines contains two integers u and v, denoting a railway between towns u and v (1 ≤ u, v ≤ n, u ≠ v).

You may assume that there is at most one railway connecting any two towns.

Output

Output one integer — the smallest possible time of the later vehicle’s arrival in town n. If it’s impossible for at least one of the vehicles to reach town n, output  - 1.

Examples
Input

4 2
1 3
3 4

Output

2

Input

4 6
1 2
1 3
1 4
2 3
2 4
3 4

Output

-1

Input

5 5
4 2
3 5
4 5
5 1
1 2

Output

3

Note

In the first sample, the train can take the route and the bus can take the route . Note that they can arrive at town 4 at the same time.

In the second sample, Absurdistan is ruled by railwaymen. There are no roads, so there’s no way for the bus to reach town 4.

思路:

开始以为铁路是题目输入给的,然后任意两点间都有公路,
然后想公路岂不是1可以直接到n,所以只要求铁路的最短路就行了。
码完发现样例2过不去,看了Note才发现题意理解错了:
有铁路的地方就没公路.

因为铁路和公路加起来是一张完全图,所以1-n要不是铁路要不就是公路,
所以只需要求另外一种路的最短路就行了。

code:
#include<cstdio>
#include<iostream>
#include<cstring>
#include<algorithm>
#include<set>
#include<cmath>
#include<queue>
#include<vector>
using namespace std;
const int maxm=405;
const int inf=1e9;
int g[maxm][maxm];
int d[maxm];
int mark[maxm];
int n,m;
int spfa(int st,int flag){//g[x][i]=flag表示连通,flag=1表示铁路,flag=0表示公路
    for(int i=1;i<=n;i++){
        d[i]=inf;
        mark[i]=0;
    }
    mark[st]=1;
    d[st]=0;
    queue<int>q;
    q.push(st);
    while(!q.empty()){
        int x=q.front();
        q.pop();
        mark[x]=0;
        for(int i=1;i<=n;i++){
            if(x==i)continue;
            if(g[x][i]==flag){//连通
                int v=i;
                if(d[v]>d[x]+1){
                    d[v]=d[x]+1;
                    if(!mark[v]){
                        mark[v]=1;
                        q.push(v);
                    }
                }
            }
        }
    }
    return d[n];
}
signed main(){
    cin>>n>>m;
    for(int i=1;i<=m;i++){
        int a,b;
        cin>>a>>b;
        g[a][b]=g[b][a]=1;
    }
    int ans=0;
    if(g[1][n]){//如果铁路直接连1-n
        ans=spfa(1,0);//则求公路最短路
    }else{//否则求铁路最短路
        ans=spfa(1,1);
    }
    if(ans==inf){
        cout<<-1<<endl;
    }else{
        cout<<ans<<endl;
    }
    return 0;
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值